//+------------------------------------------------------------------+
//|                                                       Nyquist MA |
//|                                                           brax64 |
//|                                                 www.forx-tsd.com |
//+------------------------------------------------------------------+

// Original idea by Dr. Mafred Durschner:
// http://www.vtad.de/node/1441 (in German)

#property copyright "brax64"
#property link      "www.forx-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue 

extern int NMA_Length        = 100;
extern int NMA_Sample_Length = 25; // Sampling period = 1/4 of NMA_Length
extern int MA_Method         = 3;  // LWMA
extern int MA_Price          = 5;  // PRICE_TYPICAL (H+L+C)/3

double nma[], nma_s[];
double Alpha, Gamma, Lambda;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0, nma);   SetIndexStyle(0, DRAW_LINE); SetIndexLabel(0,"NMA (" + NMA_Length + "," +  NMA_Sample_Length + ")");
   SetIndexBuffer(1, nma_s); SetIndexStyle(1, DRAW_NONE);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   IndicatorShortName("NMA");
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i;
   int limit = IndicatorCounted();
   
   if (Bars <= NMA_Length) return(0);
   if (limit < 0) return(-1);
   if (limit > 0) limit--;
   if (limit < NMA_Length) limit = NMA_Length;

   Lambda = NMA_Length / NMA_Sample_Length;
   Alpha  = Lambda * (NMA_Length - 1) / (NMA_Length - Lambda);

   for (i = Bars - limit - 1; i >= 0; i--) 
      nma_s[i] = iMA(NULL, 0, NMA_Length, 0, MA_Method, MA_Price, i);
   
   for (i = Bars - limit - 1; i >= 0; i--)
   {   
      Gamma    = iMAOnArray(nma_s, 0, NMA_Sample_Length, 0, MA_Method, i);
      nma[i]   = ((Alpha + 1) * nma_s[i]) - (Alpha * Gamma);
   }

   return(0);
}

